Index: src/backend/optimizer/plan/planner.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/optimizer/plan/planner.c,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.10.7
diff -c -r1.1.1.1 -r1.1.1.1.10.7
*** src/backend/optimizer/plan/planner.c	1 Dec 2008 09:36:26 -0000	1.1.1.1
--- src/backend/optimizer/plan/planner.c	18 Mar 2009 13:51:36 -0000	1.1.1.1.10.7
***************
*** 41,46 ****
--- 41,52 ----
  #include "utils/lsyscache.h"
  #include "utils/syscache.h"
  
+ #include "catalog/pg_partition.h"
+ #include "utils/fmgroids.h"
+ #include "catalog/indexing.h"
+ #include "utils/tqual.h"
+ #include "catalog/pg_namespace.h"
+ #include "access/hash.h"
  
  /* GUC parameter */
  double cursor_tuple_fraction = DEFAULT_CURSOR_TUPLE_FRACTION;
***************
*** 82,87 ****
--- 88,367 ----
  						List *sub_tlist,
  						AttrNumber *groupColIdx);
  static List *postprocess_setop_tlist(List *new_tlist, List *orig_tlist);
+ Oid OperatorGet(const char *operatorName,
+             Oid operatorNamespace,
+             Oid leftObjectId,
+             Oid rightObjectId,
+             bool *defined);
+ extern Oid get_relevent_partition(HeapTuple tuple, Relation rel);
+ extern Oid get_relevent_hash_partition(HeapTuple tuple, Relation rel);
+ extern Oid TypenameGetTypid	(const char *typname);
+ extern Node* coerce_to_specific_type(ParseState *pstate,
+ 		Node *  	  node,
+ 		Oid  	  targetTypeId,
+ 		const char *  	  constructName
+ 	)  ;	
+ 
+ Oid
+ get_relevent_hash_partition(HeapTuple tuple, Relation rel) {
+     ScanKeyData skey;
+     SysScanDesc pg_partscan;
+     HeapTuple   pg_parttup;
+     Relation    pg_partrel;
+ 	bool		flag;
+ 	StringInfo	str_to_hash = makeStringInfo();
+ 
+    /* Lists to identify partition id to which the row should belong.
+      * irr_part_list - list of oids of irrelevent partitions.
+      * rel_part_list - list may contain irrelevent partition along
+      *                  with relevent partition
+      */
+     List        	*distinct_part_key_list=NULL;
+     List        	*rel_part_list= NULL;
+ 	int				hash_partition_entries = 0;
+ 	unsigned int	hashValue;
+ 
+ 	flag = false;
+ 	resetStringInfo(str_to_hash);	
+ 
+     /*Scan key to scan pg_partition table on parentrelid*/
+     ScanKeyInit(&skey,
+                 Anum_pg_partition_parentrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(RelationGetRelid(rel)));
+ 
+     pg_partrel = heap_open(PartitionRelationId, RowExclusiveLock);
+     pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+                                 SnapshotNow, 1, &skey);
+ 
+ 
+     while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+     {
+ 		bool			isnull, typbyval;
+ 		int16 			len;
+ 		bool			isVariableLength;
+ 		Oid				typoutput;
+ 
+         /* Instead of pg_part Use heap_getattr for accessing bytea coluns */
+         Form_pg_partition pg_part = (Form_pg_partition) GETSTRUCT(pg_parttup);
+ 
+ 		if(pg_part->parttype == PART_HASH)
+ 		{		
+ 			/* Increase the no. of hash partition entries count. */
+ 			hash_partition_entries++;
+ 
+ 			if (!list_member_int(distinct_part_key_list, pg_part->partkey))
+ 			{
+ 				distinct_part_key_list = lappend_int(distinct_part_key_list, pg_part->partkey);
+ 
+ 		        /* Get attribute from tuple */
+ 		        Datum attr      = heap_getattr(tuple, pg_part->partkey, rel->rd_att, &isnull);
+ 
+         		/* Get len and typbyval from pg_type */
+ 	        	get_typlenbyval(pg_part->keytype, &len, &typbyval);
+ 
+ 				/* Read the list value */
+ 				getTypeOutputInfo(pg_part->keytype, &typoutput, &isVariableLength);
+ 				appendStringInfo(str_to_hash, DatumGetCString(OidFunctionCall1(typoutput, attr)));
+ 			}
+ 		}
+ 	}
+ 
+ 
+ 	hashValue = DatumGetUInt32(hash_any(str_to_hash->data, strlen(str_to_hash->data))) % 
+ 				(int)(hash_partition_entries / distinct_part_key_list->length);
+ 
+ //	elog(NOTICE, "String to be hashed : %s, Hash Value : %u", str_to_hash->data, hashValue);
+ 
+     systable_endscan(pg_partscan);
+     heap_close(pg_partrel, RowExclusiveLock);
+ 
+     /*Scan key to scan pg_partition table on parentrelid*/
+     ScanKeyInit(&skey,
+                 Anum_pg_partition_parentrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(RelationGetRelid(rel)));
+ 
+     pg_partrel = heap_open(PartitionRelationId, RowExclusiveLock);
+     pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+                                 SnapshotNow, 1, &skey);
+ 
+     while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+     {
+         bool            isnull;
+ 
+         /* Instead of pg_part Use heap_getattr for accessing bytea coluns */
+         Form_pg_partition pg_part = (Form_pg_partition) GETSTRUCT(pg_parttup);
+ 
+         if(pg_part->parttype == PART_HASH)
+         {
+ 	        /* Get min attribute from catalog */
+     	    Datum datumDashValue = heap_getattr (pg_parttup,Anum_pg_partition_hashval, 
+                                         pg_partrel->rd_att, &isnull);
+ 
+ 			if(datumDashValue == hashValue)
+ 			{
+ 				if (!list_member_oid(rel_part_list, pg_part->partrelid))		
+ 				{
+ 					rel_part_list = lappend_oid(rel_part_list, pg_part->partrelid);
+ 
+ 					if(list_length(rel_part_list) > 1)
+ 						elog(ERROR, "Found more than one matching partitions.");
+ 				}
+ 			}
+ 		}
+ 	}
+ 
+     systable_endscan(pg_partscan);
+     heap_close(pg_partrel, RowExclusiveLock);
+ 
+ //    elog (NOTICE,"Returned Oid %u", (Oid)rel_part_list->head->data.oid_value);
+ 
+ 	return (Oid)rel_part_list->head->data.oid_value;
+ }
+ 
+ static char*
+ DisplayDatum(Datum datum, Oid type)
+ {
+     Oid     typeOut;
+     bool    isVariableLength;
+ 
+     getTypeOutputInfo(type, &typeOut, &isVariableLength);
+     return (DatumGetCString(OidFunctionCall1(typeOut, datum)));
+ }
+ 
+ 
+ /* Function to get partiton id for a tuple inserted on master relation.
+  * Uses pg_partition catalog lookup to verify boundry condition.
+  * Each entry in catalog corresponds to constraint on single column.
+  */
+ 
+ Oid
+ get_relevent_partition(HeapTuple tuple, Relation rel) {
+     ScanKeyData skey;
+     SysScanDesc pg_partscan;
+     HeapTuple   pg_parttup;
+     Relation    pg_partrel;
+ 
+    /* Lists to identify partition id to which the row should belong.
+      * irr_part_list - list of oids of irrelevent partitions.
+      * rel_part_list - list may contain irrelevent partition along
+      *                  with relevent partition
+      */
+     List        *irr_part_list=NULL;
+     List        *rel_part_list= NULL;
+     ListCell    *part_oid;
+ 	Oid 		result = 0 ;
+ 
+     /*Scan key to scan pg_partition table on parentrelid*/
+     ScanKeyInit(&skey,
+                 Anum_pg_partition_parentrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(RelationGetRelid(rel)));
+ 
+     pg_partrel = heap_open(PartitionRelationId, RowExclusiveLock);
+     pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+                                 SnapshotNow, 1, &skey);
+ 
+ 
+     while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+     {
+         /* Instead of pg_part Use heap_getattr for accessing bytea coluns */
+         Form_pg_partition pg_part = (Form_pg_partition) GETSTRUCT(pg_parttup);
+         bool isnull, isdef, gte_min, lt_max, typbyval;
+         int16 len;
+         Datum short_datum;
+         Oid     typoutput;
+         bool    isVariableLength;
+ 
+         /* Get attribute from tuple */
+         Datum attr      = heap_getattr(tuple, pg_part->partkey, rel->rd_att,&isnull);
+         /* Get min attribute from catalog */
+         Datum part_attr = heap_getattr (pg_parttup,Anum_pg_partition_minval,
+                                         pg_partrel->rd_att,&isnull);
+ 
+         getTypeOutputInfo(pg_part->keytype, &typoutput, &isVariableLength);
+ 
+         /* Get len and typbyval from pg_type */
+         get_typlenbyval(pg_part->keytype, &len, &typbyval);
+ 
+         /* Three cases a. datatypes with typbyval true and fix length.
+          * b. datatypes with byval false and fix length.
+          * c. extendible datatypes where length -1.
+          */
+         if ( typbyval )
+         {
+             short_datum = 0;
+             memcpy(&short_datum, VARDATA_ANY(part_attr), len);
+             part_attr = short_datum;
+         }
+         else if (len != -1)
+         {
+ 			part_attr = (Datum)VARDATA_ANY(part_attr);
+       	}
+ 
+         /* Evaluate whether tuple value satisfies partition key cnstraint */
+         Oid min_oper = OperatorGet(">=", PG_CATALOG_NAMESPACE , pg_part->keytype,
+                                         pg_part->keytype, &isdef);
+         RegProcedure oper_proc = get_opcode(min_oper);
+         gte_min = DatumGetBool(OidFunctionCall2(oper_proc, attr, part_attr));
+ 
+ //		elog(NOTICE, "min from pg_partition : %s", DisplayDatum(part_attr, pg_part->keytype));
+ 
+         /* Similar steps for max attribute of catalog */
+ 	    part_attr = heap_getattr (pg_parttup,Anum_pg_partition_maxval,
+                                             pg_partrel->rd_att,&isnull);
+         if ( typbyval )
+         {
+             short_datum = 0;
+             memcpy(&short_datum, VARDATA_ANY(part_attr), len);
+             part_attr = short_datum;
+         }
+         else if (len != -1 )
+ 		{
+ 			part_attr = (Datum)VARDATA_ANY(part_attr);
+ 		}
+ 
+         Oid max_oper = OperatorGet("<", PG_CATALOG_NAMESPACE , pg_part->keytype,
+                                     pg_part->keytype, &isdef);
+         RegProcedure oper_proc2 = get_opcode(max_oper);
+         lt_max = DatumGetBool(OidFunctionCall2(oper_proc2,attr,part_attr));
+ 
+ //		elog(NOTICE, "max from pg_partition : %s", DisplayDatum(part_attr, pg_part->keytype));
+ //		elog(NOTICE, "value from tuple : %s\n", DisplayDatum(attr, pg_part->keytype));
+ 
+         /* Create relevent and  irrelevent partition lists */
+         if ( gte_min & lt_max )
+         {
+             if ( !list_member_oid(irr_part_list, pg_part->partrelid)    )
+                 rel_part_list = lappend_oid(rel_part_list, pg_part->partrelid);
+         }
+         else
+             irr_part_list = lappend_oid(irr_part_list, (pg_part->partrelid));
+ 
+     }
+ 
+     /* Scan through lists to get partition oid to which the tuple is to be inserted */
+     foreach(part_oid, rel_part_list)
+     {
+         if ( list_member_oid(irr_part_list, part_oid->data.oid_value) )
+ 			 result = 0;
+ 		else 
+ 			 result = (Oid)part_oid->data.oid_value;
+     }
+ 
+     systable_endscan(pg_partscan);
+     heap_close(pg_partrel, RowExclusiveLock);
+ 
+ 
+ //        elog (NOTICE,"Returned Oid %d", result);
+     /*if ( part_oid != NULL )
+         return (Oid)part_oid->data.oid_value;
+     else
+         return part_oid;*/
+ 	return result;
+ }
+ 
  
  
  /*****************************************************************************
Index: src/backend/optimizer/util/plancat.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/optimizer/util/plancat.c,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.8.1
diff -c -r1.1.1.1 -r1.1.1.1.8.1
*** src/backend/optimizer/util/plancat.c	1 Dec 2008 09:36:26 -0000	1.1.1.1
--- src/backend/optimizer/util/plancat.c	19 Feb 2009 11:51:17 -0000	1.1.1.1.8.1
***************
*** 917,922 ****
--- 917,953 ----
  	return result;
  }
  
+ 
+ /* Return parent oid for child table.
+  * Useful to find out parent in case of cross partition updates.
+  */
+ 
+ Oid
+ find_inheritance_parent(Oid inhrelid)
+ {
+     Relation    relation;
+     HeapScanDesc scan;
+     HeapTuple   inheritsTuple;
+     Oid         inhparent;
+     ScanKeyData key[1];
+ 
+ 
+     ScanKeyInit(&key[0],
+                 Anum_pg_inherits_inhrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(inhrelid));
+     relation = heap_open(InheritsRelationId, AccessShareLock);
+     scan = heap_beginscan(relation, SnapshotNow, 1, key);
+     while ((inheritsTuple = heap_getnext(scan, ForwardScanDirection)) != NULL)
+     {
+         inhparent = ((Form_pg_inherits)GETSTRUCT(inheritsTuple))->inhparent;
+     }
+     heap_endscan(scan);
+     heap_close(relation, AccessShareLock);
+     return inhparent;
+ }
+ 
+ 
  /*
   * has_unique_index
   *
Index: src/backend/parser/gram.y
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/parser/gram.y,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.8.10
diff -c -r1.1.1.2 -r1.1.1.2.8.10
*** src/backend/parser/gram.y	1 Dec 2008 09:37:47 -0000	1.1.1.2
--- src/backend/parser/gram.y	19 Mar 2009 12:34:57 -0000	1.1.1.2.8.10
***************
*** 169,174 ****
--- 169,176 ----
  
  	InsertStmt			*istmt;
  	VariableSetStmt		*vsetstmt;
+ 
+ 	PartitionFunction partFunc;
  }
  
  %type <node>	stmt schema_stmt
***************
*** 238,244 ****
  %type <list>	func_name handler_name qual_Op qual_all_Op subquery_Op
  				opt_class opt_validator
  
! %type <range>	qualified_name OptConstrFromTable
  
  %type <str>		all_Op MathOp SpecialRuleRelation
  
--- 240,246 ----
  %type <list>	func_name handler_name qual_Op qual_all_Op subquery_Op
  				opt_class opt_validator
  
! %type <range>	qualified_name OptConstrFromTable OptPartitionName
  
  %type <str>		all_Op MathOp SpecialRuleRelation
  
***************
*** 324,330 ****
  %type <defelt>	def_elem old_aggr_elem
  %type <node>	def_arg columnElem where_clause where_or_current_clause
  				a_expr b_expr c_expr func_expr AexprConst indirection_el
! 				columnref in_expr having_clause func_table array_expr
  %type <list>	row type_list array_expr_list
  %type <node>	case_expr case_arg when_clause case_default
  %type <list>	when_clause_list
--- 326,335 ----
  %type <defelt>	def_elem old_aggr_elem
  %type <node>	def_arg columnElem where_clause where_or_current_clause
  				a_expr b_expr c_expr func_expr AexprConst indirection_el
! 				columnref in_expr having_clause func_table array_expr 
! 
! %type <list>	ListPartitionList  
! 
  %type <list>	row type_list array_expr_list
  %type <node>	case_expr case_arg when_clause case_default
  %type <list>	when_clause_list
***************
*** 386,391 ****
--- 391,401 ----
  %type <with> 	with_clause
  %type <list>	cte_list
  
+ %type <list>	RangePartitions ListPartitions PartitionColumns
+ %type <node> 	PartitioningData OptPartition ListPartition RangePartition
+ /* %type <node>	LeftVal RightVal */
+ 
+ // %type <partFunc> Partitioning_function
  
  /*
   * If you make any token changes, update the keyword table in
***************
*** 435,441 ****
  	KEY
  
  	LANCOMPILER LANGUAGE LARGE_P LAST_P LEADING LEAST LEFT LEVEL
! 	LIKE LIMIT LISTEN LOAD LOCAL LOCALTIME LOCALTIMESTAMP LOCATION
  	LOCK_P LOGIN_P
  
  	MAPPING MATCH MAXVALUE MINUTE_P MINVALUE MODE MONTH_P MOVE
--- 445,451 ----
  	KEY
  
  	LANCOMPILER LANGUAGE LARGE_P LAST_P LEADING LEAST LEFT LEVEL
! 	LIKE LIMIT LIST1  LISTEN LOAD LOCAL LOCALTIME LOCALTIMESTAMP LOCATION
  	LOCK_P LOGIN_P
  
  	MAPPING MATCH MAXVALUE MINUTE_P MINVALUE MODE MONTH_P MOVE
***************
*** 447,465 ****
  	OBJECT_P OF OFF OFFSET OIDS OLD ON ONLY OPERATOR OPTION OR
  	ORDER OUT_P OUTER_P OVERLAPS OVERLAY OWNED OWNER
  
! 	PARSER PARTIAL PASSWORD PLACING PLANS POSITION
  	PRECISION PRESERVE PREPARE PREPARED PRIMARY
  	PRIOR PRIVILEGES PROCEDURAL PROCEDURE
  
  	QUOTE
  
! 	READ REAL REASSIGN RECHECK RECURSIVE REFERENCES REINDEX RELATIVE_P RELEASE
  	RENAME REPEATABLE REPLACE REPLICA RESET RESTART RESTRICT RETURNING RETURNS
  	REVOKE RIGHT ROLE ROLLBACK ROW ROWS RULE
  
  	SAVEPOINT SCHEMA SCROLL SEARCH SECOND_P SECURITY SELECT SEQUENCE
  	SERIALIZABLE SESSION SESSION_USER SET SETOF SHARE
! 	SHOW SIMILAR SIMPLE SMALLINT SOME STABLE STANDALONE_P START STATEMENT
  	STATISTICS STDIN STDOUT STORAGE STRICT_P STRIP_P SUBSTRING SUPERUSER_P
  	SYMMETRIC SYSID SYSTEM_P
  
--- 457,475 ----
  	OBJECT_P OF OFF OFFSET OIDS OLD ON ONLY OPERATOR OPTION OR
  	ORDER OUT_P OUTER_P OVERLAPS OVERLAY OWNED OWNER
  
! 	PARSER PARTIAL PARTITION PARTITIONS PASSWORD PLACING PLANS POSITION
  	PRECISION PRESERVE PREPARE PREPARED PRIMARY
  	PRIOR PRIVILEGES PROCEDURAL PROCEDURE
  
  	QUOTE
  
! 	RANGE READ REAL REASSIGN RECHECK RECURSIVE REFERENCES REINDEX RELATIVE_P RELEASE
  	RENAME REPEATABLE REPLACE REPLICA RESET RESTART RESTRICT RETURNING RETURNS
  	REVOKE RIGHT ROLE ROLLBACK ROW ROWS RULE
  
  	SAVEPOINT SCHEMA SCROLL SEARCH SECOND_P SECURITY SELECT SEQUENCE
  	SERIALIZABLE SESSION SESSION_USER SET SETOF SHARE
! 	SHOW SIMILAR SIMPLE SMALLINT SOME SPLIT STABLE STANDALONE_P START STATEMENT
  	STATISTICS STDIN STDOUT STORAGE STRICT_P STRIP_P SUBSTRING SUPERUSER_P
  	SYMMETRIC SYSID SYSTEM_P
  
***************
*** 1493,1500 ****
  		;
  
  alter_table_cmd:
  			/* ALTER TABLE <name> ADD [COLUMN] <coldef> */
! 			ADD_P opt_column columnDef
  				{
  					AlterTableCmd *n = makeNode(AlterTableCmd);
  					n->subtype = AT_AddColumn;
--- 1503,1519 ----
  		;
  
  alter_table_cmd:
+ 			/* ALTER TABLE <name> ADD PARTITION BY RANGE (col, ...) (<name> START val,.... END val,....) */
+ 			ADD_P RANGE PARTITION RangePartition
+ 				{
+ 					AlterTableCmd *n = makeNode(AlterTableCmd);
+ 					n->subtype = AT_AddPartition;
+ 					n->def = $4;
+ 					$$ = (Node *)n;
+ 				}		
+ 
  			/* ALTER TABLE <name> ADD [COLUMN] <coldef> */
! 			| ADD_P opt_column columnDef
  				{
  					AlterTableCmd *n = makeNode(AlterTableCmd);
  					n->subtype = AT_AddColumn;
***************
*** 1544,1549 ****
--- 1563,1609 ----
  					n->def = (Node *) makeString($6);
  					$$ = (Node *)n;
  				}
+ 			| DROP RANGE PARTITION qualified_name 
+ 				{
+ 					AlterTableCmd *n = makeNode(AlterTableCmd);
+ 					n->subtype = AT_DropPartitionByName;
+ 
+                     Partition *partition = makeNode(Partition);
+                     partition->partName = $4;
+                     partition->partitionCheck = NULL;
+ 
+ 					n->def = (Node *)partition;
+ 					$$ = (Node *)n;
+ 				}
+ 			| DROP RANGE PARTITION RangePartition
+ 				{
+ 					AlterTableCmd *n = makeNode(AlterTableCmd);
+ 					n->subtype = AT_DropPartitionByRange;
+ 					n->def = $4;
+ 					$$ = (Node *)n;
+ 				}
+ 			| UPDATE RANGE PARTITION RangePartition TO RangePartition
+ 				{
+ 					AlterTableCmd *n = makeNode(AlterTableCmd);
+ 					UpdatePartitionStmt *u = makeNode(UpdatePartitionStmt);
+ 					u->prev = (Partition *)$4;
+ 					u->after = (Partition *)$6;
+ 					n->subtype = AT_UpdatePartition;
+ 					n->def = (Node *)u;
+ 					$$ = (Node *)n;
+ 				}
+ 			| SPLIT RANGE PARTITION qualified_name AT VALUES '(' ListPartitionList ')' INTO qualified_name AND qualified_name
+ 				{
+ 					AlterTableCmd *n = makeNode(AlterTableCmd);
+ 					SplitPartitionStmt *s = makeNode(SplitPartitionStmt);
+ 					s->partNames = lappend(s->partNames, $4);
+ 					s->partNames = lappend(s->partNames, $11);
+ 					s->partNames = lappend(s->partNames, $13);
+ 					s->splitValues = $8;
+ 					n->subtype = AT_SplitPartition;
+ 					n->def = (Node *)s;
+ 					$$ = (Node *)n;
+ 				}
  			/* ALTER TABLE <name> DROP [COLUMN] <colname> [RESTRICT|CASCADE] */
  			| DROP opt_column ColId opt_drop_behavior
  				{
***************
*** 1946,1953 ****
   *
   *****************************************************************************/
  
! CreateStmt:	CREATE OptTemp TABLE qualified_name '(' OptTableElementList ')'
! 			OptInherit OptWith OnCommitOption OptTableSpace
  				{
  					CreateStmt *n = makeNode(CreateStmt);
  					$4->istemp = $2;
--- 2006,2013 ----
   *
   *****************************************************************************/
  
! CreateStmt: CREATE OptTemp TABLE qualified_name '(' OptTableElementList ')'
! 			   OptInherit OptWith OnCommitOption OptTableSpace OptPartition 
  				{
  					CreateStmt *n = makeNode(CreateStmt);
  					$4->istemp = $2;
***************
*** 1958,1967 ****
  					n->options = $9;
  					n->oncommit = $10;
  					n->tablespacename = $11;
  					$$ = (Node *)n;
  				}
  		| CREATE OptTemp TABLE qualified_name OF qualified_name
! 			'(' OptTableElementList ')' OptWith OnCommitOption OptTableSpace
  				{
  					/* SQL99 CREATE TABLE OF <UDT> (cols) seems to be satisfied
  					 * by our inheritance capabilities. Let's try it...
--- 2018,2028 ----
  					n->options = $9;
  					n->oncommit = $10;
  					n->tablespacename = $11;
+                     n->partAttr = $12;
  					$$ = (Node *)n;
  				}
  		| CREATE OptTemp TABLE qualified_name OF qualified_name
! 			'(' OptTableElementList ')' OptWith OnCommitOption OptTableSpace OptPartition
  				{
  					/* SQL99 CREATE TABLE OF <UDT> (cols) seems to be satisfied
  					 * by our inheritance capabilities. Let's try it...
***************
*** 1975,1984 ****
--- 2036,2167 ----
  					n->options = $10;
  					n->oncommit = $11;
  					n->tablespacename = $12;
+                     n->partAttr =  $13;
  					$$ = (Node *)n;
  				}
  		;
  
+ OptPartition: PARTITION BY PartitioningData { $$ = $3; }  
+ 		| {$$ = NULL;}
+     	;
+ 
+ PartitionColumns: ColId 				{$$ = list_make1(makeString($1));}
+ 		| PartitionColumns ',' ColId 	{$$ = lappend($1, makeString($3));}
+ 		;
+ 
+ PartitioningData: LIST1  '(' PartitionColumns ')'  '(' ListPartitions  ')'
+ 				{
+ 					PartitionAttrs *partData = makeNode(PartitionAttrs);
+ 					partData->partFunc = PART_LIST;
+ 					partData->numberOfPartitions = 0;
+ 					partData->colName = $3;
+ 					partData->partitions = $6;
+ 					$$ = (Node *)partData;
+ 				}
+ 			
+ 		| RANGE '(' PartitionColumns ')' '(' RangePartitions ')'
+ 				{
+                     PartitionAttrs *partData = makeNode(PartitionAttrs);
+                     partData->partFunc = PART_RANGE;
+                     partData->numberOfPartitions = 0;
+                     partData->colName = $3;
+                     partData->partitions = $6;
+                     $$ = (Node *)partData;					
+ 				}	
+ 
+ 
+ 		| ColId '(' PartitionColumns ')'  PARTITIONS ICONST 
+ 				{
+ 					PartitionAttrs *partData = makeNode(PartitionAttrs);
+ 					if(strcasecmp($1, "hash") != 0)
+ 						elog(ERROR, "Not a valid partition type.");
+ 					partData->partFunc = PART_HASH;
+ 					partData->numberOfPartitions = $6;
+ 					partData->colName = $3;
+ 					partData->partitions =  NULL;
+ 					$$ = (Node *)partData;
+ 				}
+ 		;
+ 
+ ListPartitions: ListPartition 			{ $$ = list_make1($1);}
+ 	| ListPartitions ',' ListPartition 	{ $$ = lappend($1, $3);}
+ 	;
+ 
+ RangePartitions :  RangePartition { $$ = list_make1($1); }
+         | RangePartitions ',' RangePartition { $$ = lappend($1, $3); }
+         ;
+ 
+ ListPartitionList: a_expr 			{ $$ = list_make1($1);}
+ 	| ListPartitionList ',' a_expr 	{ $$ = lappend($1, $3);}
+ 	;
+ 
+ 
+ OptPartitionName: /* Empty  */ {$$ = NULL;}		
+ 	| qualified_name
+ 	;
+ 
+ ListPartition :	OptPartitionName '(' ListPartitionList ')'   OptTableSpace
+ 				{
+ 
+ 					Partition *partition = makeNode(Partition);
+ 					Constraint *constraint = NULL;
+ 					
+ 					partition->partName = $1;
+ 
+ 					/* Make the constraint node */
+ 					constraint = makeNode(Constraint);
+ 	
+ 					constraint->contype = PART_LIST;
+ 					constraint->name = NULL;
+ 					constraint->raw_expr = (Node *)$3; 
+ 					constraint->cooked_expr = NULL;
+ 					constraint->keys = NULL;
+ 					constraint->indexspace = NULL;
+ 					constraint->partition_list_values = $3;
+ 
+ 					partition->partitionCheck = constraint;
+ 					partition->tablespacename = $5;
+ 					$$ = (Node *)partition;
+ 				}
+     	;
+ 
+ RangePartition : OptPartitionName '(' START ListPartitionList END_P ListPartitionList ')' OptTableSpace
+ 				{
+ 
+ 						Partition *partition = makeNode(Partition);
+ 						Constraint *constraint = NULL;
+ 
+ 						partition->partName = $1;
+ 
+ 						/* Make the constraint node */
+ 						constraint = makeNode(Constraint);
+ 						constraint->contype = PART_RANGE;
+ 						constraint->min_value = $4;
+ 						constraint->max_value = $6;
+ 						constraint->name = NULL;
+ 			
+ 						/* constraint->raw_expr = $3; */
+ 
+ 						constraint->cooked_expr = NULL;
+ 						constraint->keys = NULL;
+ 						constraint->indexspace = NULL;
+ 
+ 						partition->partitionCheck = constraint;
+ 						partition->tablespacename = $8;
+ 						$$ = (Node *)partition;
+ 				}
+         ;
+ 
+ 
+ /***
+ part_column_list:
+ 			ColId
+ 					{ $$ = list_make1($1); }
+ 			|part_column_list ',' ColId 
+ 					{ $$ = lappend($1, $3); }
+ 		;
+ ****/
+ 
  /*
   * Redundancy here is needed to avoid shift/reduce conflicts,
   * since TEMP is not a reserved word.  See also OptTempTableName.
***************
*** 9344,9360 ****
  				{
  					$$ = makeNullAConst(@1);
  				}
  		;
  
  Iconst:		ICONST									{ $$ = $1; };
  Sconst:		SCONST									{ $$ = $1; };
  RoleId:		ColId									{ $$ = $1; };
- 
  SignedIconst: Iconst								{ $$ = $1; }
  			| '+' Iconst							{ $$ = + $2; }
  			| '-' Iconst							{ $$ = - $2; }
  		;
- 
  /*
   * Name classification hierarchy.
   *
--- 9527,9592 ----
  				{
  					$$ = makeNullAConst(@1);
  				}
+ /*
+ 			| AexprConst '+' AexprConst 
+ 				{
+ 					Node *l = $1;
+ 					Node *r = $3;	
+ 					int 	iresult;
+ 					float   fresult, flval, frval;
+ 
+ 					if(l->val.type == T_Integer && r->val.type == T_Integer)
+ 					{
+ 						iresult = l->val.val.ival + r->val.val.ival;
+ 						$$ = makeIntConst(iresult, @1);
+ 					}
+ 					else if(l->val.type == T_Integer && r->val.type == T_Float)
+                     {
+ 						sscanf(r.val.val.str, "%f", &frval);
+ 						fresult = (float)l->val.val.ival + frval;
+                         $$ = makeFloatConst(fresult, @1);
+                     }
+ 					else if(l->val.type == T_Float && r->val.type == T_Integer)
+                     {
+ 						sscanf(l.val.val.str, "%f", &flval);
+ 						fresult = flval + (float)r->val.val.ival;
+                         $$ = makeFloatConst(fresult, @1);
+                     }
+ 					else if(l->val.type == T_Float && r->val.type == T_Float)
+                     {
+ 						sscanf(l.val.val.str, "%f", &flval);
+ 						sscanf(r.val.val.str, "%f", &frval);
+ 						fresult = flval + frval;
+                         $$ = makeFloatConst(fresult, @1);
+                     }
+ 					else
+ 						elog(ERROR, "Invalid expression.");
+ 				}
+ 					if ( l->val.type == T_Float) || r->val.type == T_Float )
+ 					{
+ 						$$ == makeFloatConst($1, @1);
+ 					}
+ 					else if ( l->val.type == T_Integer && r->val.type == T_Integer )
+ 						$$ == makeIntConst($1, @1);
+ 					else
+ 						elog (ERROR, "Invalid expression ");					
+ 				}					
+ 			| AexprConst '-' AexprConst
+ 				{
+ 				}
+ 			| AexprConst '/' AexprConst
+ 			| AexprConst '*' AexprConst
+ 			| AexprConst '||' AexprConst
+ */
  		;
  
  Iconst:		ICONST									{ $$ = $1; };
  Sconst:		SCONST									{ $$ = $1; };
  RoleId:		ColId									{ $$ = $1; };
  SignedIconst: Iconst								{ $$ = $1; }
  			| '+' Iconst							{ $$ = + $2; }
  			| '-' Iconst							{ $$ = - $2; }
  		;
  /*
   * Name classification hierarchy.
   *
***************
*** 9556,9561 ****
--- 9788,9795 ----
  			| OWNER
  			| PARSER
  			| PARTIAL
+ 			| PARTITION
+ 			| PARTITIONS
  			| PASSWORD
  			| PLANS
  			| PREPARE
***************
*** 9599,9604 ****
--- 9833,9839 ----
  			| SHARE
  			| SHOW
  			| SIMPLE
+ 			| SPLIT
  			| STABLE
  			| STANDALONE_P
  			| START
***************
*** 9729,9738 ****
--- 9964,9975 ----
  			| JOIN
  			| LEFT
  			| LIKE
+ 			| LIST1
  			| NATURAL
  			| NOTNULL
  			| OUTER_P
  			| OVERLAPS
+ 			| RANGE
  			| RIGHT
  			| SIMILAR
  			| VERBOSE
Index: src/backend/parser/keywords.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/parser/keywords.c,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.8.3
diff -c -r1.1.1.1 -r1.1.1.1.8.3
*** src/backend/parser/keywords.c	1 Dec 2008 09:36:26 -0000	1.1.1.1
--- src/backend/parser/keywords.c	17 Mar 2009 12:50:55 -0000	1.1.1.1.8.3
***************
*** 186,191 ****
--- 186,192 ----
  	{"greatest", GREATEST, COL_NAME_KEYWORD},
  	{"group", GROUP_P, RESERVED_KEYWORD},
  	{"handler", HANDLER, UNRESERVED_KEYWORD},
+ //	{"hash", HASH, UNRESERVED_KEYWORD},
  	{"having", HAVING, RESERVED_KEYWORD},
  	{"header", HEADER_P, UNRESERVED_KEYWORD},
  	{"hold", HOLD, UNRESERVED_KEYWORD},
***************
*** 231,236 ****
--- 232,238 ----
  	{"level", LEVEL, UNRESERVED_KEYWORD},
  	{"like", LIKE, TYPE_FUNC_NAME_KEYWORD},
  	{"limit", LIMIT, RESERVED_KEYWORD},
+ 	{"list", LIST1, UNRESERVED_KEYWORD},
  	{"listen", LISTEN, UNRESERVED_KEYWORD},
  	{"load", LOAD, UNRESERVED_KEYWORD},
  	{"local", LOCAL, UNRESERVED_KEYWORD},
***************
*** 291,296 ****
--- 293,300 ----
  	{"owner", OWNER, UNRESERVED_KEYWORD},
  	{"parser", PARSER, UNRESERVED_KEYWORD},
  	{"partial", PARTIAL, UNRESERVED_KEYWORD},
+ 	{"partition", PARTITION, UNRESERVED_KEYWORD},
+ 	{"partitions", PARTITIONS, UNRESERVED_KEYWORD},
  	{"password", PASSWORD, UNRESERVED_KEYWORD},
  	{"placing", PLACING, RESERVED_KEYWORD},
  	{"plans", PLANS, UNRESERVED_KEYWORD},
***************
*** 305,310 ****
--- 309,315 ----
  	{"procedural", PROCEDURAL, UNRESERVED_KEYWORD},
  	{"procedure", PROCEDURE, UNRESERVED_KEYWORD},
  	{"quote", QUOTE, UNRESERVED_KEYWORD},
+ 	{"range", RANGE, UNRESERVED_KEYWORD},
  	{"read", READ, UNRESERVED_KEYWORD},
  	{"real", REAL, COL_NAME_KEYWORD},
  	{"reassign", REASSIGN, UNRESERVED_KEYWORD},
***************
*** 349,354 ****
--- 354,360 ----
  	{"simple", SIMPLE, UNRESERVED_KEYWORD},
  	{"smallint", SMALLINT, COL_NAME_KEYWORD},
  	{"some", SOME, RESERVED_KEYWORD},
+ 	{"split", SPLIT, UNRESERVED_KEYWORD},
  	{"stable", STABLE, UNRESERVED_KEYWORD},
  	{"standalone", STANDALONE_P, UNRESERVED_KEYWORD},
  	{"start", START, UNRESERVED_KEYWORD},
